## disk_read

The disk_read function is called to read data from the storage device.

    DRESULT disk_read (
      BYTE pdrv,     /* [IN] Physical drive number */
      BYTE* buff,    /* [OUT] Pointer to the read data buffer */
      LBA_t sector,  /* [IN] Start sector number */
      UINT count     /* [IN] Number of sectros to read */
    );

#### Parameters

pdrv
  Physical drive number to identify the target device.
buff
  Pointer to the first item of the byte array to store read data. Size of read data will be the sector size * `count` bytes.
sector
  Start sector number in LBA. The data type `LBA_t` is an alias of `DWORD` or `QWORD` depends on the configuration option.
count
  Number of sectors to read.

#### Return Value

RES_OK (0)
  The function succeeded.
RES_ERROR
  An unrecoverable hard error occured during the read operation.
RES_PARERR
  Invalid parameter.
RES_NOTRDY
  The device has not been initialized.

#### Description

Read/write operation to the generic storage devices, such as memory card, hadddisk and optical disk, is done in unit of block of data bytes called sector. FatFs supports the sector size in range of 512 to 4096 bytes. When FatFs is configured for fixed sector size (`FF_MIN_SS == FF_MAX_SS`, this is the most case), the generic read/write function must work at this sector size only. When FatFs is configured for variable sector size (`FF_MIN_SS < FF_MAX_SS`), the sector size of medium is inquired with `disk_ioctl` function after `disk_initialize` function succeeds.

There are some considerations about the memory addres passed via `buff`. It is not that always aligned with the word boundary, because the argument is defined as `BYTE*`. The unaligned transfer request can occure at direct transfer. If the bus architecture, especially DMA controller, does not allow unaligned memory access, it should be solved in this function. If it is the case, there are some workarounds described below to avoid this issue.

- Convert word transfer to byte transfer with some trick in this function. - Recommended.
- On the `f_read()` calls, avoid long read request that includes a whole of sector. - Any direct transfer never occures.
- On the `f_read(fp, data, btw, bw)` calls, make sure that `(((UINT)data & 3) == (f_tell(fp) & 3))` is true. - Word alignment of `buff` is guaranteed.

Also the memory area may be out of reach in DMA. This is the case if it is located on the tightly coupled memory which is usually used for stack. Use double buffered transfer, or avoid to define file I/O buffer, `FATFS` and `FIL` structure as local variables where on the stack.

Generally, a multiple sector read request must not be split into single sector transactions to the storage device, or read throughput gets worse.

Return